// Compiled by ClojureScript 1.7.145 {:static-fns true, :optimize-constants true}
goog.provide('om_bootstrap.grid');
goog.require('cljs.core');
goog.require('om_bootstrap.types');
goog.require('om_bootstrap.util');
goog.require('om_tools.dom');
goog.require('schema.core');
om_bootstrap.grid.Grid = om_bootstrap.types.bootstrap(cljs.core.PersistentArrayMap.fromArray([schema.core.optional_key(cljs.core.cst$kw$fluid_QMARK_),schema.core.Bool], true, false));
om_bootstrap.grid.col_keys = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 16, [cljs.core.cst$kw$md_DASH_pull,null,cljs.core.cst$kw$lg,null,cljs.core.cst$kw$lg_DASH_push,null,cljs.core.cst$kw$sm,null,cljs.core.cst$kw$lg_DASH_pull,null,cljs.core.cst$kw$xs_DASH_push,null,cljs.core.cst$kw$xs,null,cljs.core.cst$kw$sm_DASH_offset,null,cljs.core.cst$kw$sm_DASH_pull,null,cljs.core.cst$kw$lg_DASH_offset,null,cljs.core.cst$kw$md_DASH_push,null,cljs.core.cst$kw$sm_DASH_push,null,cljs.core.cst$kw$md_DASH_offset,null,cljs.core.cst$kw$xs_DASH_pull,null,cljs.core.cst$kw$md,null,cljs.core.cst$kw$xs_DASH_offset,null], null), null);
om_bootstrap.grid.Col = om_bootstrap.types.bootstrap(cljs.core.zipmap(cljs.core.map.cljs$core$IFn$_invoke$arity$2(schema.core.optional_key,om_bootstrap.grid.col_keys),cljs.core.repeat.cljs$core$IFn$_invoke$arity$1(schema.core.Int)));
var ufv___28845 = schema.utils.use_fn_validation;
var output_schema28836_28846 = om_bootstrap.types.Component;
var input_schema28837_28847 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(om_bootstrap.grid.Grid,cljs.core.with_meta(cljs.core.cst$sym$opts,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$Grid], null))),schema.core.Any], null);
var input_checker28838_28848 = schema.core.checker(input_schema28837_28847);
var output_checker28839_28849 = schema.core.checker(output_schema28836_28846);
/**
 * Inputs: [opts :- Grid & children]
 *   Returns: t/Component
 * 
 *   Generates a wrapper for a bootstrap grid.
 */
om_bootstrap.grid.grid = ((function (ufv___28845,output_schema28836_28846,input_schema28837_28847,input_checker28838_28848,output_checker28839_28849){
return (function om_bootstrap$grid$grid(var_args){
var args__5577__auto__ = [];
var len__5570__auto___28850 = arguments.length;
var i__5571__auto___28851 = (0);
while(true){
if((i__5571__auto___28851 < len__5570__auto___28850)){
args__5577__auto__.push((arguments[i__5571__auto___28851]));

var G__28852 = (i__5571__auto___28851 + (1));
i__5571__auto___28851 = G__28852;
continue;
} else {
}
break;
}

var argseq__5578__auto__ = ((((1) < args__5577__auto__.length))?(new cljs.core.IndexedSeq(args__5577__auto__.slice((1)),(0))):null);
return om_bootstrap.grid.grid.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__5578__auto__);
});})(ufv___28845,output_schema28836_28846,input_schema28837_28847,input_checker28838_28848,output_checker28839_28849))
;

om_bootstrap.grid.grid.cljs$core$IFn$_invoke$arity$variadic = ((function (ufv___28845,output_schema28836_28846,input_schema28837_28847,input_checker28838_28848,output_checker28839_28849){
return (function (G__28840,rest28841){
var validate__8403__auto__ = ufv___28845.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___28853 = cljs.core.list_STAR_.cljs$core$IFn$_invoke$arity$2(G__28840,rest28841);
var temp__4425__auto___28854 = (input_checker28838_28848.cljs$core$IFn$_invoke$arity$1 ? input_checker28838_28848.cljs$core$IFn$_invoke$arity$1(args__8404__auto___28853) : input_checker28838_28848.call(null,args__8404__auto___28853));
if(cljs.core.truth_(temp__4425__auto___28854)){
var error__8405__auto___28855 = temp__4425__auto___28854;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$grid,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$t_SLASH_Component,cljs.core.cst$kw$doc,"Generates a wrapper for a bootstrap grid."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28855], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema28837_28847,cljs.core.cst$kw$value,args__8404__auto___28853,cljs.core.cst$kw$error,error__8405__auto___28855], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var opts = G__28840;
var children = rest28841;
while(true){
var vec__28844 = om_bootstrap.types.separate.cljs$core$IFn$_invoke$arity$3(om_bootstrap.grid.Grid,opts,cljs.core.PersistentArrayMap.EMPTY);
var bs = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__28844,(0),null);
var props = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__28844,(1),null);
var class$ = (cljs.core.truth_(cljs.core.cst$kw$fluid_QMARK_.cljs$core$IFn$_invoke$arity$1(bs))?"container-fluid":"container");
return om_tools.dom.element(React.DOM.div,om_bootstrap.util.merge_props.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([props,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$class,class$], null)], 0)),(new cljs.core.PersistentVector(null,1,(5),cljs.core.PersistentVector.EMPTY_NODE,[children],null)));
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___28856 = (output_checker28839_28849.cljs$core$IFn$_invoke$arity$1 ? output_checker28839_28849.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker28839_28849.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___28856)){
var error__8405__auto___28857 = temp__4425__auto___28856;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$grid,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$t_SLASH_Component,cljs.core.cst$kw$doc,"Generates a wrapper for a bootstrap grid."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28857], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema28836_28846,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___28857], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___28845,output_schema28836_28846,input_schema28837_28847,input_checker28838_28848,output_checker28839_28849))
;

om_bootstrap.grid.grid.cljs$lang$maxFixedArity = (1);

om_bootstrap.grid.grid.cljs$lang$applyTo = ((function (ufv___28845,output_schema28836_28846,input_schema28837_28847,input_checker28838_28848,output_checker28839_28849){
return (function (seq28842){
var G__28843 = cljs.core.first(seq28842);
var seq28842__$1 = cljs.core.next(seq28842);
return om_bootstrap.grid.grid.cljs$core$IFn$_invoke$arity$variadic(G__28843,seq28842__$1);
});})(ufv___28845,output_schema28836_28846,input_schema28837_28847,input_checker28838_28848,output_checker28839_28849))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.grid.grid),schema.core.make_fn_schema(output_schema28836_28846,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema28837_28847], null)));
var ufv___28866 = schema.utils.use_fn_validation;
var output_schema28858_28867 = om_bootstrap.types.Component;
var input_schema28859_28868 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(schema.core.Any,cljs.core.with_meta(cljs.core.cst$sym$opts,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any], null))),schema.core.Any], null);
var input_checker28860_28869 = schema.core.checker(input_schema28859_28868);
var output_checker28861_28870 = schema.core.checker(output_schema28858_28867);
/**
 * Inputs: [opts & children]
 *   Returns: t/Component
 * 
 *   Generates a Bootstrap row element.
 */
om_bootstrap.grid.row = ((function (ufv___28866,output_schema28858_28867,input_schema28859_28868,input_checker28860_28869,output_checker28861_28870){
return (function om_bootstrap$grid$row(var_args){
var args__5577__auto__ = [];
var len__5570__auto___28871 = arguments.length;
var i__5571__auto___28872 = (0);
while(true){
if((i__5571__auto___28872 < len__5570__auto___28871)){
args__5577__auto__.push((arguments[i__5571__auto___28872]));

var G__28873 = (i__5571__auto___28872 + (1));
i__5571__auto___28872 = G__28873;
continue;
} else {
}
break;
}

var argseq__5578__auto__ = ((((1) < args__5577__auto__.length))?(new cljs.core.IndexedSeq(args__5577__auto__.slice((1)),(0))):null);
return om_bootstrap.grid.row.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__5578__auto__);
});})(ufv___28866,output_schema28858_28867,input_schema28859_28868,input_checker28860_28869,output_checker28861_28870))
;

om_bootstrap.grid.row.cljs$core$IFn$_invoke$arity$variadic = ((function (ufv___28866,output_schema28858_28867,input_schema28859_28868,input_checker28860_28869,output_checker28861_28870){
return (function (G__28862,rest28863){
var validate__8403__auto__ = ufv___28866.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___28874 = cljs.core.list_STAR_.cljs$core$IFn$_invoke$arity$2(G__28862,rest28863);
var temp__4425__auto___28875 = (input_checker28860_28869.cljs$core$IFn$_invoke$arity$1 ? input_checker28860_28869.cljs$core$IFn$_invoke$arity$1(args__8404__auto___28874) : input_checker28860_28869.call(null,args__8404__auto___28874));
if(cljs.core.truth_(temp__4425__auto___28875)){
var error__8405__auto___28876 = temp__4425__auto___28875;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$row,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$t_SLASH_Component,cljs.core.cst$kw$doc,"Generates a Bootstrap row element."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28876], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema28859_28868,cljs.core.cst$kw$value,args__8404__auto___28874,cljs.core.cst$kw$error,error__8405__auto___28876], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var opts = G__28862;
var children = rest28863;
while(true){
return om_tools.dom.element(React.DOM.div,om_bootstrap.util.merge_props.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([opts,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$class,"row"], null)], 0)),(new cljs.core.PersistentVector(null,1,(5),cljs.core.PersistentVector.EMPTY_NODE,[children],null)));
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___28877 = (output_checker28861_28870.cljs$core$IFn$_invoke$arity$1 ? output_checker28861_28870.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker28861_28870.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___28877)){
var error__8405__auto___28878 = temp__4425__auto___28877;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$row,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$t_SLASH_Component,cljs.core.cst$kw$doc,"Generates a Bootstrap row element."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28878], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema28858_28867,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___28878], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___28866,output_schema28858_28867,input_schema28859_28868,input_checker28860_28869,output_checker28861_28870))
;

om_bootstrap.grid.row.cljs$lang$maxFixedArity = (1);

om_bootstrap.grid.row.cljs$lang$applyTo = ((function (ufv___28866,output_schema28858_28867,input_schema28859_28868,input_checker28860_28869,output_checker28861_28870){
return (function (seq28864){
var G__28865 = cljs.core.first(seq28864);
var seq28864__$1 = cljs.core.next(seq28864);
return om_bootstrap.grid.row.cljs$core$IFn$_invoke$arity$variadic(G__28865,seq28864__$1);
});})(ufv___28866,output_schema28858_28867,input_schema28859_28868,input_checker28860_28869,output_checker28861_28870))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.grid.row),schema.core.make_fn_schema(output_schema28858_28867,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema28859_28868], null)));
var ufv___28890 = schema.utils.use_fn_validation;
var output_schema28879_28891 = om_bootstrap.types.Component;
var input_schema28880_28892 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(om_bootstrap.grid.Col,cljs.core.with_meta(cljs.core.cst$sym$opts,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$Col], null))),schema.core.Any], null);
var input_checker28881_28893 = schema.core.checker(input_schema28880_28892);
var output_checker28882_28894 = schema.core.checker(output_schema28879_28891);
/**
 * Inputs: [opts :- Col & children]
 *   Returns: t/Component
 * 
 *   Generates a Bootstrap column element.
 */
om_bootstrap.grid.col = ((function (ufv___28890,output_schema28879_28891,input_schema28880_28892,input_checker28881_28893,output_checker28882_28894){
return (function om_bootstrap$grid$col(var_args){
var args__5577__auto__ = [];
var len__5570__auto___28895 = arguments.length;
var i__5571__auto___28896 = (0);
while(true){
if((i__5571__auto___28896 < len__5570__auto___28895)){
args__5577__auto__.push((arguments[i__5571__auto___28896]));

var G__28897 = (i__5571__auto___28896 + (1));
i__5571__auto___28896 = G__28897;
continue;
} else {
}
break;
}

var argseq__5578__auto__ = ((((1) < args__5577__auto__.length))?(new cljs.core.IndexedSeq(args__5577__auto__.slice((1)),(0))):null);
return om_bootstrap.grid.col.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__5578__auto__);
});})(ufv___28890,output_schema28879_28891,input_schema28880_28892,input_checker28881_28893,output_checker28882_28894))
;

om_bootstrap.grid.col.cljs$core$IFn$_invoke$arity$variadic = ((function (ufv___28890,output_schema28879_28891,input_schema28880_28892,input_checker28881_28893,output_checker28882_28894){
return (function (G__28883,rest28884){
var validate__8403__auto__ = ufv___28890.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___28898 = cljs.core.list_STAR_.cljs$core$IFn$_invoke$arity$2(G__28883,rest28884);
var temp__4425__auto___28899 = (input_checker28881_28893.cljs$core$IFn$_invoke$arity$1 ? input_checker28881_28893.cljs$core$IFn$_invoke$arity$1(args__8404__auto___28898) : input_checker28881_28893.call(null,args__8404__auto___28898));
if(cljs.core.truth_(temp__4425__auto___28899)){
var error__8405__auto___28900 = temp__4425__auto___28899;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$col,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$t_SLASH_Component,cljs.core.cst$kw$doc,"Generates a Bootstrap column element."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28900], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema28880_28892,cljs.core.cst$kw$value,args__8404__auto___28898,cljs.core.cst$kw$error,error__8405__auto___28900], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var opts = G__28883;
var children = rest28884;
while(true){
var vec__28887 = om_bootstrap.types.separate.cljs$core$IFn$_invoke$arity$3(om_bootstrap.grid.Col,opts,cljs.core.PersistentArrayMap.EMPTY);
var bs = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__28887,(0),null);
var props = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__28887,(1),null);
var class$ = om_tools.dom.class_set(cljs.core.zipmap(cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (vec__28887,bs,props,validate__8403__auto__,ufv___28890,output_schema28879_28891,input_schema28880_28892,input_checker28881_28893,output_checker28882_28894){
return (function (p__28888){
var vec__28889 = p__28888;
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__28889,(0),null);
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__28889,(1),null);
return [cljs.core.str("col-"),cljs.core.str(cljs.core.name(k)),cljs.core.str("-"),cljs.core.str(v)].join('');
});})(vec__28887,bs,props,validate__8403__auto__,ufv___28890,output_schema28879_28891,input_schema28880_28892,input_checker28881_28893,output_checker28882_28894))
,cljs.core.select_keys(bs,om_bootstrap.grid.col_keys)),cljs.core.repeat.cljs$core$IFn$_invoke$arity$1(true)));
return om_tools.dom.element(React.DOM.div,om_bootstrap.util.merge_props.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([props,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$class,class$], null)], 0)),(new cljs.core.PersistentVector(null,1,(5),cljs.core.PersistentVector.EMPTY_NODE,[children],null)));
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___28901 = (output_checker28882_28894.cljs$core$IFn$_invoke$arity$1 ? output_checker28882_28894.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker28882_28894.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___28901)){
var error__8405__auto___28902 = temp__4425__auto___28901;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$col,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$t_SLASH_Component,cljs.core.cst$kw$doc,"Generates a Bootstrap column element."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28902], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema28879_28891,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___28902], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___28890,output_schema28879_28891,input_schema28880_28892,input_checker28881_28893,output_checker28882_28894))
;

om_bootstrap.grid.col.cljs$lang$maxFixedArity = (1);

om_bootstrap.grid.col.cljs$lang$applyTo = ((function (ufv___28890,output_schema28879_28891,input_schema28880_28892,input_checker28881_28893,output_checker28882_28894){
return (function (seq28885){
var G__28886 = cljs.core.first(seq28885);
var seq28885__$1 = cljs.core.next(seq28885);
return om_bootstrap.grid.col.cljs$core$IFn$_invoke$arity$variadic(G__28886,seq28885__$1);
});})(ufv___28890,output_schema28879_28891,input_schema28880_28892,input_checker28881_28893,output_checker28882_28894))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.grid.col),schema.core.make_fn_schema(output_schema28879_28891,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema28880_28892], null)));
