// Compiled by ClojureScript 1.7.145 {:static-fns true, :optimize-constants true}
goog.provide('om_bootstrap.util');
goog.require('cljs.core');
goog.require('om.core');
goog.require('schema.core');
/**
 * Returns a map that consists of the rest of the maps conj-ed onto
 *   the first.  If a key occurs in more than one map, the mapping(s)
 *   from the latter (left-to-right) will be combined with the mapping in
 *   the result by looking up the proper merge function and in the
 *   supplied map of key -> merge-fn and using that for the big merge. If
 *   a key doesn't have a merge function, the right value wins (as with
 *   merge).
 */
om_bootstrap.util.merge_with_fns = (function om_bootstrap$util$merge_with_fns(k__GT_fn,maps){
var merge_entry = (function om_bootstrap$util$merge_with_fns_$_merge_entry(m,e){
var k = cljs.core.key(e);
var v = cljs.core.val(e);
var temp__4423__auto__ = (function (){var and__4500__auto__ = cljs.core.contains_QMARK_(m,k);
if(and__4500__auto__){
return (k__GT_fn.cljs$core$IFn$_invoke$arity$1 ? k__GT_fn.cljs$core$IFn$_invoke$arity$1(k) : k__GT_fn.call(null,k));
} else {
return and__4500__auto__;
}
})();
if(cljs.core.truth_(temp__4423__auto__)){
var f = temp__4423__auto__;
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(m,k,(function (){var G__23503 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(m,k);
var G__23504 = v;
return (f.cljs$core$IFn$_invoke$arity$2 ? f.cljs$core$IFn$_invoke$arity$2(G__23503,G__23504) : f.call(null,G__23503,G__23504));
})());
} else {
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(m,k,v);
}
});
var merge = (function om_bootstrap$util$merge_with_fns_$_merge(m1,m2){
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(merge_entry,(function (){var or__4512__auto__ = m1;
if(cljs.core.truth_(or__4512__auto__)){
return or__4512__auto__;
} else {
return cljs.core.PersistentArrayMap.EMPTY;
}
})(),cljs.core.seq(m2));
});
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(merge,cljs.core.PersistentArrayMap.EMPTY,maps);
});
var ufv___23510 = schema.utils.use_fn_validation;
var output_schema23505_23511 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.Any], null);
var input_schema23506_23512 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(schema.core.Any,cljs.core.with_meta(cljs.core.cst$sym$x,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$s_SLASH_Any], null)))], null);
var input_checker23507_23513 = schema.core.checker(input_schema23506_23512);
var output_checker23508_23514 = schema.core.checker(output_schema23505_23511);
/**
 * Inputs: [x :- s/Any]
 *   Returns: [s/Any]
 */
om_bootstrap.util.collectify = ((function (ufv___23510,output_schema23505_23511,input_schema23506_23512,input_checker23507_23513,output_checker23508_23514){
return (function om_bootstrap$util$collectify(G__23509){
var validate__8403__auto__ = ufv___23510.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___23515 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__23509], null);
var temp__4425__auto___23516 = (input_checker23507_23513.cljs$core$IFn$_invoke$arity$1 ? input_checker23507_23513.cljs$core$IFn$_invoke$arity$1(args__8404__auto___23515) : input_checker23507_23513.call(null,args__8404__auto___23515));
if(cljs.core.truth_(temp__4425__auto___23516)){
var error__8405__auto___23517 = temp__4425__auto___23516;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$collectify,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$s_SLASH_Any], null)], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___23517], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema23506_23512,cljs.core.cst$kw$value,args__8404__auto___23515,cljs.core.cst$kw$error,error__8405__auto___23517], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var x = G__23509;
while(true){
if(cljs.core.sequential_QMARK_(x)){
return x;
} else {
return new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [x], null);
}
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___23518 = (output_checker23508_23514.cljs$core$IFn$_invoke$arity$1 ? output_checker23508_23514.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker23508_23514.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___23518)){
var error__8405__auto___23519 = temp__4425__auto___23518;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$collectify,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$s_SLASH_Any], null)], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___23519], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema23505_23511,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___23519], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___23510,output_schema23505_23511,input_schema23506_23512,input_checker23507_23513,output_checker23508_23514))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.util.collectify),schema.core.make_fn_schema(output_schema23505_23511,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema23506_23512], null)));
/**
 * This is the same as om.core/get-props. We added it to get around
 *   the new precondition in Om 0.8.0.
 */
om_bootstrap.util.get_props = (function om_bootstrap$util$get_props(x){
return (x.props["__om_cursor"]);
});
var ufv___23525 = schema.utils.use_fn_validation;
var output_schema23520_23526 = schema.core.Bool;
var input_schema23521_23527 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(schema.core.Any,cljs.core.with_meta(cljs.core.cst$sym$x,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any], null)))], null);
var input_checker23522_23528 = schema.core.checker(input_schema23521_23527);
var output_checker23523_23529 = schema.core.checker(output_schema23520_23526);
/**
 * Inputs: [x]
 *   Returns: s/Bool
 */
om_bootstrap.util.om_component_QMARK_ = ((function (ufv___23525,output_schema23520_23526,input_schema23521_23527,input_checker23522_23528,output_checker23523_23529){
return (function om_bootstrap$util$om_component_QMARK_(G__23524){
var validate__8403__auto__ = ufv___23525.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___23530 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__23524], null);
var temp__4425__auto___23531 = (input_checker23522_23528.cljs$core$IFn$_invoke$arity$1 ? input_checker23522_23528.cljs$core$IFn$_invoke$arity$1(args__8404__auto___23530) : input_checker23522_23528.call(null,args__8404__auto___23530));
if(cljs.core.truth_(temp__4425__auto___23531)){
var error__8405__auto___23532 = temp__4425__auto___23531;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$om_DASH_component_QMARK_,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$s_SLASH_Bool], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___23532], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema23521_23527,cljs.core.cst$kw$value,args__8404__auto___23530,cljs.core.cst$kw$error,error__8405__auto___23532], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var x = G__23524;
while(true){
return cljs.core.boolean$(om_bootstrap.util.get_props(x));
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___23533 = (output_checker23523_23529.cljs$core$IFn$_invoke$arity$1 ? output_checker23523_23529.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker23523_23529.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___23533)){
var error__8405__auto___23534 = temp__4425__auto___23533;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$om_DASH_component_QMARK_,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$s_SLASH_Bool], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___23534], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema23520_23526,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___23534], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___23525,output_schema23520_23526,input_schema23521_23527,input_checker23522_23528,output_checker23523_23529))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.util.om_component_QMARK_),schema.core.make_fn_schema(output_schema23520_23526,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema23521_23527], null)));
var ufv___23540 = schema.utils.use_fn_validation;
var output_schema23535_23541 = schema.core.Bool;
var input_schema23536_23542 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(schema.core.Any,cljs.core.with_meta(cljs.core.cst$sym$child,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any], null)))], null);
var input_checker23537_23543 = schema.core.checker(input_schema23536_23542);
var output_checker23538_23544 = schema.core.checker(output_schema23535_23541);
/**
 * Inputs: [child]
 *   Returns: s/Bool
 * 
 *   TODO: Once Om updates its externs to include this file, we can
 *   remove the janky aget call.
 */
om_bootstrap.util.strict_valid_component_QMARK_ = ((function (ufv___23540,output_schema23535_23541,input_schema23536_23542,input_checker23537_23543,output_checker23538_23544){
return (function om_bootstrap$util$strict_valid_component_QMARK_(G__23539){
var validate__8403__auto__ = ufv___23540.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___23545 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__23539], null);
var temp__4425__auto___23546 = (input_checker23537_23543.cljs$core$IFn$_invoke$arity$1 ? input_checker23537_23543.cljs$core$IFn$_invoke$arity$1(args__8404__auto___23545) : input_checker23537_23543.call(null,args__8404__auto___23545));
if(cljs.core.truth_(temp__4425__auto___23546)){
var error__8405__auto___23547 = temp__4425__auto___23546;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$strict_DASH_valid_DASH_component_QMARK_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$s_SLASH_Bool,cljs.core.cst$kw$doc,"TODO: Once Om updates its externs to include this file, we can\n  remove the janky aget call."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___23547], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema23536_23542,cljs.core.cst$kw$value,args__8404__auto___23545,cljs.core.cst$kw$error,error__8405__auto___23547], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var child = G__23539;
while(true){
return (React["isValidComponent"]).call(null,child);
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___23548 = (output_checker23538_23544.cljs$core$IFn$_invoke$arity$1 ? output_checker23538_23544.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker23538_23544.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___23548)){
var error__8405__auto___23549 = temp__4425__auto___23548;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$strict_DASH_valid_DASH_component_QMARK_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$s_SLASH_Bool,cljs.core.cst$kw$doc,"TODO: Once Om updates its externs to include this file, we can\n  remove the janky aget call."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___23549], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema23535_23541,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___23549], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___23540,output_schema23535_23541,input_schema23536_23542,input_checker23537_23543,output_checker23538_23544))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.util.strict_valid_component_QMARK_),schema.core.make_fn_schema(output_schema23535_23541,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema23536_23542], null)));
var ufv___23555 = schema.utils.use_fn_validation;
var output_schema23550_23556 = schema.core.Bool;
var input_schema23551_23557 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(schema.core.Any,cljs.core.with_meta(cljs.core.cst$sym$child,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any], null)))], null);
var input_checker23552_23558 = schema.core.checker(input_schema23551_23557);
var output_checker23553_23559 = schema.core.checker(output_schema23550_23556);
/**
 * Inputs: [child]
 *   Returns: s/Bool
 * 
 *   Returns true if the supplied argument is a valid React component,
 *   false otherwise.
 */
om_bootstrap.util.valid_component_QMARK_ = ((function (ufv___23555,output_schema23550_23556,input_schema23551_23557,input_checker23552_23558,output_checker23553_23559){
return (function om_bootstrap$util$valid_component_QMARK_(G__23554){
var validate__8403__auto__ = ufv___23555.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___23560 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__23554], null);
var temp__4425__auto___23561 = (input_checker23552_23558.cljs$core$IFn$_invoke$arity$1 ? input_checker23552_23558.cljs$core$IFn$_invoke$arity$1(args__8404__auto___23560) : input_checker23552_23558.call(null,args__8404__auto___23560));
if(cljs.core.truth_(temp__4425__auto___23561)){
var error__8405__auto___23562 = temp__4425__auto___23561;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$valid_DASH_component_QMARK_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$s_SLASH_Bool,cljs.core.cst$kw$doc,"Returns true if the supplied argument is a valid React component,\n  false otherwise."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___23562], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema23551_23557,cljs.core.cst$kw$value,args__8404__auto___23560,cljs.core.cst$kw$error,error__8405__auto___23562], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var child = G__23554;
while(true){
var or__4512__auto__ = typeof child === 'string';
if(or__4512__auto__){
return or__4512__auto__;
} else {
var or__4512__auto____$1 = typeof child === 'number';
if(or__4512__auto____$1){
return or__4512__auto____$1;
} else {
return om_bootstrap.util.strict_valid_component_QMARK_(child);
}
}
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___23563 = (output_checker23553_23559.cljs$core$IFn$_invoke$arity$1 ? output_checker23553_23559.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker23553_23559.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___23563)){
var error__8405__auto___23564 = temp__4425__auto___23563;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$valid_DASH_component_QMARK_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$s_SLASH_Bool,cljs.core.cst$kw$doc,"Returns true if the supplied argument is a valid React component,\n  false otherwise."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___23564], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema23550_23556,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___23564], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___23555,output_schema23550_23556,input_schema23551_23557,input_checker23552_23558,output_checker23553_23559))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.util.valid_component_QMARK_),schema.core.make_fn_schema(output_schema23550_23556,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema23551_23557], null)));
var ufv___23570 = schema.utils.use_fn_validation;
var output_schema23565_23571 = schema.core.Bool;
var input_schema23566_23572 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(schema.core.Any,cljs.core.with_meta(cljs.core.cst$sym$children,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any], null)))], null);
var input_checker23567_23573 = schema.core.checker(input_schema23566_23572);
var output_checker23568_23574 = schema.core.checker(output_schema23565_23571);
/**
 * Inputs: [children]
 *   Returns: s/Bool
 * 
 *   Returns true if the supplied sequence contains some valid React component,
 *   false otherwise.
 */
om_bootstrap.util.some_valid_component_QMARK_ = ((function (ufv___23570,output_schema23565_23571,input_schema23566_23572,input_checker23567_23573,output_checker23568_23574){
return (function om_bootstrap$util$some_valid_component_QMARK_(G__23569){
var validate__8403__auto__ = ufv___23570.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___23575 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__23569], null);
var temp__4425__auto___23576 = (input_checker23567_23573.cljs$core$IFn$_invoke$arity$1 ? input_checker23567_23573.cljs$core$IFn$_invoke$arity$1(args__8404__auto___23575) : input_checker23567_23573.call(null,args__8404__auto___23575));
if(cljs.core.truth_(temp__4425__auto___23576)){
var error__8405__auto___23577 = temp__4425__auto___23576;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$some_DASH_valid_DASH_component_QMARK_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$s_SLASH_Bool,cljs.core.cst$kw$doc,"Returns true if the supplied sequence contains some valid React component,\n  false otherwise."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___23577], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema23566_23572,cljs.core.cst$kw$value,args__8404__auto___23575,cljs.core.cst$kw$error,error__8405__auto___23577], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var children = G__23569;
while(true){
return cljs.core.boolean$(cljs.core.some(om_bootstrap.util.valid_component_QMARK_,children));
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___23578 = (output_checker23568_23574.cljs$core$IFn$_invoke$arity$1 ? output_checker23568_23574.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker23568_23574.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___23578)){
var error__8405__auto___23579 = temp__4425__auto___23578;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$some_DASH_valid_DASH_component_QMARK_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$s_SLASH_Bool,cljs.core.cst$kw$doc,"Returns true if the supplied sequence contains some valid React component,\n  false otherwise."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___23579], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema23565_23571,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___23579], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___23570,output_schema23565_23571,input_schema23566_23572,input_checker23567_23573,output_checker23568_23574))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.util.some_valid_component_QMARK_),schema.core.make_fn_schema(output_schema23565_23571,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema23566_23572], null)));
/**
 * Generates a new function that calls each supplied side-effecting
 *   function.
 */
om_bootstrap.util.chain_fns = (function om_bootstrap$util$chain_fns(l,r){
if(cljs.core.truth_((function (){var and__4500__auto__ = l;
if(cljs.core.truth_(and__4500__auto__)){
return r;
} else {
return and__4500__auto__;
}
})())){
return (function() { 
var G__23580__delegate = function (args){
cljs.core.apply.cljs$core$IFn$_invoke$arity$2(l,args);

return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(r,args);
};
var G__23580 = function (var_args){
var args = null;
if (arguments.length > 0) {
var G__23581__i = 0, G__23581__a = new Array(arguments.length -  0);
while (G__23581__i < G__23581__a.length) {G__23581__a[G__23581__i] = arguments[G__23581__i + 0]; ++G__23581__i;}
  args = new cljs.core.IndexedSeq(G__23581__a,0);
} 
return G__23580__delegate.call(this,args);};
G__23580.cljs$lang$maxFixedArity = 0;
G__23580.cljs$lang$applyTo = (function (arglist__23582){
var args = cljs.core.seq(arglist__23582);
return G__23580__delegate(args);
});
G__23580.cljs$core$IFn$_invoke$arity$variadic = G__23580__delegate;
return G__23580;
})()
;
} else {
var or__4512__auto__ = l;
if(cljs.core.truth_(or__4512__auto__)){
return or__4512__auto__;
} else {
return r;
}
}
});
/**
 * Map of React keyword to a custom function for its merge. Tries to
 *   do a decent job with event handlers as well; currently only
 *   handles :on-select :on-click, :on-blur, kebab-cased as om-tools
 *   prefers.
 */
om_bootstrap.util.react_merges = (function (){var merge_class = (function (l,r){
return [cljs.core.str(l),cljs.core.str(" "),cljs.core.str(r)].join('');
});
var orig_fn = ((function (merge_class){
return (function (l,r){
var or__4512__auto__ = l;
if(cljs.core.truth_(or__4512__auto__)){
return or__4512__auto__;
} else {
return r;
}
});})(merge_class))
;
var empty_fn = ((function (merge_class,orig_fn){
return (function (_,___$1){
return null;
});})(merge_class,orig_fn))
;
return cljs.core.PersistentHashMap.fromArrays([cljs.core.cst$kw$children,cljs.core.cst$kw$key,cljs.core.cst$kw$ref,cljs.core.cst$kw$on_DASH_blur,cljs.core.cst$kw$on_DASH_click,cljs.core.cst$kw$className,cljs.core.cst$kw$style,cljs.core.cst$kw$on_DASH_select,cljs.core.cst$kw$class],[empty_fn,empty_fn,orig_fn,om_bootstrap.util.chain_fns,om_bootstrap.util.chain_fns,merge_class,cljs.core.merge,om_bootstrap.util.chain_fns,merge_class]);
})();
/**
 * Merges two maps that represent React properties. Merges occur
 *   according to the functions defined in `react-merges`.
 */
om_bootstrap.util.merge_props = (function om_bootstrap$util$merge_props(var_args){
var args__5577__auto__ = [];
var len__5570__auto___23584 = arguments.length;
var i__5571__auto___23585 = (0);
while(true){
if((i__5571__auto___23585 < len__5570__auto___23584)){
args__5577__auto__.push((arguments[i__5571__auto___23585]));

var G__23586 = (i__5571__auto___23585 + (1));
i__5571__auto___23585 = G__23586;
continue;
} else {
}
break;
}

var argseq__5578__auto__ = ((((0) < args__5577__auto__.length))?(new cljs.core.IndexedSeq(args__5577__auto__.slice((0)),(0))):null);
return om_bootstrap.util.merge_props.cljs$core$IFn$_invoke$arity$variadic(argseq__5578__auto__);
});

om_bootstrap.util.merge_props.cljs$core$IFn$_invoke$arity$variadic = (function (prop_maps){
var react_merge = (function om_bootstrap$util$react_merge(xs){
return om_bootstrap.util.merge_with_fns(om_bootstrap.util.react_merges,xs);
});
var normalize_class = (function om_bootstrap$util$normalize_class(m){
if(cljs.core.contains_QMARK_(m,cljs.core.cst$kw$class)){
return react_merge(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(m,cljs.core.cst$kw$class),new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$className,cljs.core.cst$kw$class.cljs$core$IFn$_invoke$arity$1(m)], null)], null));
} else {
return m;
}
});
return react_merge(cljs.core.map.cljs$core$IFn$_invoke$arity$2(normalize_class,prop_maps));
});

om_bootstrap.util.merge_props.cljs$lang$maxFixedArity = (0);

om_bootstrap.util.merge_props.cljs$lang$applyTo = (function (seq23583){
return om_bootstrap.util.merge_props.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq(seq23583));
});
/**
 * Returns a basic, shallow copy of the supplied JS object.
 */
om_bootstrap.util.copy_js = (function om_bootstrap$util$copy_js(arr){
var ret = {};
var seq__23595_23599 = cljs.core.seq(cljs.core.js_keys(arr));
var chunk__23596_23600 = null;
var count__23597_23601 = (0);
var i__23598_23602 = (0);
while(true){
if((i__23598_23602 < count__23597_23601)){
var k_23603 = chunk__23596_23600.cljs$core$IIndexed$_nth$arity$2(null,i__23598_23602);
if(cljs.core.truth_(arr.hasOwnProperty(k_23603))){
(ret[k_23603] = (arr[k_23603]));
} else {
}

var G__23604 = seq__23595_23599;
var G__23605 = chunk__23596_23600;
var G__23606 = count__23597_23601;
var G__23607 = (i__23598_23602 + (1));
seq__23595_23599 = G__23604;
chunk__23596_23600 = G__23605;
count__23597_23601 = G__23606;
i__23598_23602 = G__23607;
continue;
} else {
var temp__4425__auto___23608 = cljs.core.seq(seq__23595_23599);
if(temp__4425__auto___23608){
var seq__23595_23609__$1 = temp__4425__auto___23608;
if(cljs.core.chunked_seq_QMARK_(seq__23595_23609__$1)){
var c__5315__auto___23610 = cljs.core.chunk_first(seq__23595_23609__$1);
var G__23611 = cljs.core.chunk_rest(seq__23595_23609__$1);
var G__23612 = c__5315__auto___23610;
var G__23613 = cljs.core.count(c__5315__auto___23610);
var G__23614 = (0);
seq__23595_23599 = G__23611;
chunk__23596_23600 = G__23612;
count__23597_23601 = G__23613;
i__23598_23602 = G__23614;
continue;
} else {
var k_23615 = cljs.core.first(seq__23595_23609__$1);
if(cljs.core.truth_(arr.hasOwnProperty(k_23615))){
(ret[k_23615] = (arr[k_23615]));
} else {
}

var G__23616 = cljs.core.next(seq__23595_23609__$1);
var G__23617 = null;
var G__23618 = (0);
var G__23619 = (0);
seq__23595_23599 = G__23616;
chunk__23596_23600 = G__23617;
count__23597_23601 = G__23618;
i__23598_23602 = G__23619;
continue;
}
} else {
}
}
break;
}

return ret;
});
/**
 * Merges the supplied extra properties into the underlying Om cursor
 *   and calls the constructor to clone the React component.
 * 
 *   Requires that the supplied child has an Om cursor attached to it! 
 */
om_bootstrap.util.clone_om = (function om_bootstrap$util$clone_om(child,extra_props){
var om_props = om_bootstrap.util.get_props(child);
return child.constructor((function (){var G__23621 = om_bootstrap.util.copy_js(child.props);
(G__23621["__om_cursor"] = ((cljs.core.fn_QMARK_(extra_props))?(extra_props.cljs$core$IFn$_invoke$arity$1 ? extra_props.cljs$core$IFn$_invoke$arity$1(om_props) : extra_props.call(null,om_props)):om_bootstrap.util.merge_props.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([om_props,extra_props], 0))));

return G__23621;
})());
});
/**
 * This function is called if the React component child was NOT
 *   generated by Om. Merges the supplied properties into the -props
 *   field of the supplied React component and creates a shallow copy.
 */
om_bootstrap.util.clone_basic_react = (function om_bootstrap$util$clone_basic_react(child,extra_props){
var props = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(child.props,cljs.core.array_seq([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
var new_props = cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([((cljs.core.fn_QMARK_(extra_props))?(extra_props.cljs$core$IFn$_invoke$arity$1 ? extra_props.cljs$core$IFn$_invoke$arity$1(props) : extra_props.call(null,props)):om_bootstrap.util.merge_props.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([props,extra_props], 0))),(function (){var temp__4425__auto__ = cljs.core.cst$kw$children.cljs$core$IFn$_invoke$arity$1(props);
if(cljs.core.truth_(temp__4425__auto__)){
var children = temp__4425__auto__;
return new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$children,children], null);
} else {
return null;
}
})()], 0));
return child.constructor(cljs.core.clj__GT_js(new_props));
});
/**
 * Returns a shallow copy of the supplied component (child); the copy
 *   will have any props provided by extra-props merged in. Props are
 *   merged in the same manner as merge-props, so props like :class will
 *   be merged intelligently.
 * 
 *   extra-props can be a function of the old props that returns new
 *   props, OR it can be a map of props.
 * 
 *   If the supplied child is an Om component, any supplied extra
 *   properties will be merged into the underlying cursor and accessible
 *   in the Om constructor.
 */
om_bootstrap.util.clone_with_props = (function om_bootstrap$util$clone_with_props(var_args){
var args23622 = [];
var len__5570__auto___23625 = arguments.length;
var i__5571__auto___23626 = (0);
while(true){
if((i__5571__auto___23626 < len__5570__auto___23625)){
args23622.push((arguments[i__5571__auto___23626]));

var G__23627 = (i__5571__auto___23626 + (1));
i__5571__auto___23626 = G__23627;
continue;
} else {
}
break;
}

var G__23624 = args23622.length;
switch (G__23624) {
case 1:
return om_bootstrap.util.clone_with_props.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return om_bootstrap.util.clone_with_props.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args23622.length)].join('')));

}
});

om_bootstrap.util.clone_with_props.cljs$core$IFn$_invoke$arity$1 = (function (child){
return om_bootstrap.util.clone_with_props.cljs$core$IFn$_invoke$arity$2(child,cljs.core.PersistentArrayMap.EMPTY);
});

om_bootstrap.util.clone_with_props.cljs$core$IFn$_invoke$arity$2 = (function (child,extra_props){
if(cljs.core.not(om_bootstrap.util.strict_valid_component_QMARK_(child))){
return child;
} else {
if((cljs.core.map_QMARK_(extra_props)) && (cljs.core.empty_QMARK_(extra_props))){
return child.constructor(child.props);
} else {
if(cljs.core.truth_(om_bootstrap.util.om_component_QMARK_(child))){
return om_bootstrap.util.clone_om(child,extra_props);
} else {
return om_bootstrap.util.clone_basic_react(child,extra_props);

}
}
}
});

om_bootstrap.util.clone_with_props.cljs$lang$maxFixedArity = 2;
